/* file user.c */
#include <fork.h>
#include <io.h>
#include <stdlib.h>
#include <math.h> /* the user has to declare not only the */
#include "tdr.h"  /* libraries s(he) uses but also the    */
									/* used by the skeleton                 */ 

/* skeleton pqueue input */
#define pqueue_printData(message,ptritem) {pprintf("%s %d\n",message,*ptritem);}
/* end of skeleton pqueue input */
#include "pqueue.skl"

#define initData(e,i) {\
    if (e = (int *) shmalloc( sizeof( int ))) *e = i;\
     else {\
      pprintf("Error allocating data\n");\
      exit(1);\
    }\
  }

sh pqueue_type * pq;
sh int seed, times;

void main( void )
{
  pr int i, decision, *e; 

  pprintf("starting: shared heap available memory = %d \n",shavail());
  pqueue_init(&pq); 
  pprintf("Initialization completed\n");
  pqueue_scan(pq);
  if (!$) {
    pprintf("\nseed (odd positive number, please) = "); 
    scanf("%d",&seed);
    pprintf("\ntimes = "); 
    scanf("%d",&times);
    pprintf("executing with seed = %d, %d times ...\n",seed,times);
  }
  barrier;
  srand(2*$*seed+1);
  for (i=__PROC_NR__; i<times; i+=__STARTED_PROCS__) {
    decision = abs(rand()) % 2;
    pprintf("decision %d \n",decision);
    if (decision) { /* pqueue_put */
      initData(e,i); 
      pprintf("calling Put element %d\n", *e);
      pqueue_put( pq, (char *) e );
    }
    else { /* pqueue_get */
    if (e = (int *) pqueue_get( pq )) {
      pprintf("Get element %d\n", (int) *e); 
      shfree(e);
    }
    else pprintf("can not catch an element\n");
    }
  }
 barrier;
 pqueue_scan( pq );
 while (pq->size != 0) {
    if (e = (int *) pqueue_get( pq )) {
      pprintf("Get element %d\n", (int) *e); 
      shfree(e);
    }
    else pprintf("can not catch an element\n");
  }
 pqueue_close(&pq);
 barrier;
 pprintf("finish: shared heap available memory = %d \n",shavail());
 barrier;
}
